import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'dart:math';

class exo2 extends StatefulWidget{
  @override
  _exo2State createState() => _exo2State();
}

class _exo2State extends State<exo2> {
  var appBar= AppBar(title: Text('Exo 2'),);

  double _currentSliderValueX = 0.0;
  double _currentSliderValueZ = 0.0;
  double _currentSliderValueScale = 100;
  bool _checkbox = false;
  TextStyle textStyle = TextStyle(fontSize: 16, fontWeight: FontWeight.bold,);

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar:appBar,
      body: ListView(children: [
          Container(
            clipBehavior: Clip.hardEdge,
            decoration: BoxDecoration(color: Colors.blueGrey),
            height: ((MediaQuery.of(context).size.height)*0.7)-appBar.preferredSize.height,
            child:Transform.rotate(
              angle: _currentSliderValueZ *(pi/10),
                child: Transform.scale(
                    scale: _currentSliderValueScale/100,
                    child: Transform(
                        transform: Matrix4.rotationX(_currentSliderValueX *(pi/10)),
                        origin: Offset(0,(((MediaQuery.of(context).size.height)*0.7)-appBar.preferredSize.height)/2),
                        child: Transform(
                            transform: Matrix4.rotationY(_checkbox ? pi : 0),
                            origin: Offset(((MediaQuery.of(context).size.width)/2),0),
                            child: Center(child: Image.network('https://picsum.photos/512/1024'))
                        ),
                    ),
                ),
            ),
        ),
        Row(mainAxisSize: MainAxisSize.min,
            children: <Widget>[
              Container(width: 90,child:Text('Rotation X:', style: textStyle,textAlign: TextAlign.center,),padding: EdgeInsets.fromLTRB(8, 0, 0, 0),),
              Container(height:((MediaQuery.of(context).size.height)/7)-appBar.preferredSize.height,width: MediaQuery.of(context).size.width-90,child: Slider(
                  value: _currentSliderValueX,
                  min: 0, max: 20, divisions: 20,
                  label: _currentSliderValueX.round().toString(),
                  onChanged: (double value) {
                    setState(() {_currentSliderValueX = value;});
                  }
              ),
              ),
            ]
        ),
        Row(mainAxisSize: MainAxisSize.min,
            children: <Widget>[
              Container(width: 90,child:Text('Rotation Z:', style: textStyle,textAlign: TextAlign.center,),padding: EdgeInsets.fromLTRB(8, 0, 0, 0),),
              Container(height:((MediaQuery.of(context).size.height)/7)-appBar.preferredSize.height,width: MediaQuery.of(context).size.width-90,child: Slider(
                  value: _currentSliderValueZ,
                  min: 0, max: 20, divisions: 20,
                  label: _currentSliderValueZ.round().toString(),
                  onChanged: (double value) {
                    setState(() {_currentSliderValueZ = value;});
                  }
              ),
              ),
            ]
        ),
        Row(mainAxisSize: MainAxisSize.min,
            children: <Widget>[
            Container(width: 90,child:Text('Taille:', style: textStyle,textAlign: TextAlign.center,),padding: EdgeInsets.fromLTRB(8, 0, 0, 0),),
            Container(height:((MediaQuery.of(context).size.height)/7)-appBar.preferredSize.height,width: MediaQuery.of(context).size.width-90,child: Slider(
              value: _currentSliderValueScale,
              min: 0, max: 100, divisions: 100,
              label: _currentSliderValueScale.round().toString(),
              onChanged: (double value) {
                setState(() {_currentSliderValueScale = value;});
              }
            ),
            ),
          ]
        ),
        Row(mainAxisSize: MainAxisSize.min,
            children: <Widget>[
              Container(width: 90,child:Text('Mirroir:', style: textStyle, textAlign: TextAlign.center,),padding: EdgeInsets.fromLTRB(8, 0, 0, 0),),
              Container(height:((MediaQuery.of(context).size.height)/7)-appBar.preferredSize.height,width: 90,child: Checkbox(
                  value: _checkbox,
                  onChanged: (value) {
                    setState(() {_checkbox = !_checkbox;});
                  }
                ),
              ),
            ]
        ),
      ]),
    );
  }
}

/*
Transform(transform: Matrix4.rotationX(_currentSliderValueX *(pi/10))
              ..rotateZ(_currentSliderValueZ *(pi/10))
              ..scale(_currentSliderValueScale/100),
                origin: Offset.zero,
                child: Center(child: Image.network('https://picsum.photos/512/1024'))
            ),
 */